/*utf8解析行 Don't remove or modify this first line!*/
#ifndef WNCOMMONSOCKET_H
#define WNCOMMONSOCKET_H

//#include "ACCallback.h"
#include "WNCommonSocketDelegate.h"
#include "WNSocketObserver.h"
#include "WNWorkThread.h"
#include <sys/socket.h>
#include <string>

using namespace std;
#ifndef WIN32
#   ifndef WINTYPEDEF
#   define WINTYPEDEF
        typedef bool BOOL;
        #define TRUE true
        #define FALSE false
        typedef unsigned short USHORT;
        typedef const char* LPCTSTR;
        typedef unsigned int UINT;
        typedef int INT;
        typedef struct sockaddr_in SOCKADDR_IN;
        typedef struct sockaddr SOCKADDR;
        typedef unsigned int DWORD;
        typedef string CString;
        typedef void* HWND;
        #define LRESULT long
        #define CALLBACK
        #define WINAPI
        #define _tcstoul strtoul
        #define _T(str) str
        typedef long LONG;
        typedef LONG WPARAM;
        typedef LONG LPARAM;
        typedef void* LPVOID;
        typedef void* HANDLE;
        typedef void* ACWinProc;
        typedef int SOCKET;
#   endif
#endif

class WNCommonSocket 
    : public WNSocketObserverTarget
    , public WNSocketObserverTargetDelegate
    , public WNWorkThreadDelegate
{
#ifdef WIN32
    typedef LRESULT (WNCommonSocket::*ACWindowHookProc)(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
    typedef ACCallback<WNDPROC, WNCommonSocket, WNCommonSocket::ACWindowHookProc> ACWinProc;
#endif
public:
    WNCommonSocket(void);
    virtual ~WNCommonSocket(void);
    virtual BOOL CreateSocket();
    virtual BOOL SetSocketAddress(LPCTSTR lpAddress);
    virtual BOOL SetSocketAddress(LPCTSTR lpAddress, UINT uPort);
    virtual BOOL SetSocketAddress(SOCKADDR* pSockAddr);
    virtual BOOL EnterObserverLoop(BOOL bInNewThread);
    virtual BOOL ExitObserverLoop();
    virtual void CloseSocket();
    virtual BOOL AcceptSocket(WNCommonSocket* pNewSocket, SOCKADDR* pSockAddr = NULL, int* pSockAddrLen = NULL);
    virtual BOOL AcceptSocket(WNCommonSocket& newSocket, CString* pstrSockAddr = NULL, int* pSockAddrLen = NULL);
    virtual BOOL ConnectSocket(LPCTSTR lpszHostAddress);
    virtual BOOL ConnectSocket(SOCKADDR* pHostAddress);
    virtual BOOL IOCtl(long lCommand, DWORD* lpArgument);
    virtual BOOL SetSockOpt(int nOptionName, const void* lpOptionValue, int nOptionLen, int nLevel = SOL_SOCKET);
    virtual BOOL GetSockOpt(int nOptionName, void* lpOptionValue,int* lpOptionLen, int nLevel = SOL_SOCKET);
    virtual BOOL Listen(int nConnectionBacklog);
    virtual BOOL GetPeerName(CString& strIp, UINT& uPort);
    virtual BOOL GetPeerName(SOCKADDR* lpSockAddr, int* lpSockAddrLen);
    virtual BOOL GetSockName(CString& strIp, UINT& uPort);
    virtual BOOL GetSockName(SOCKADDR* lpSockAddr, int* lpSockAddrLen);
    virtual void SetReceiveBuffer(void* pBuffer, UINT uBufferLen);
    virtual DWORD ReceivedDataLen();
    virtual int Receive(void* lpBuf, int nBufLen, int nFlags = 0);
    virtual int ReceiveFrom(void* lpBuf, int nBufLen, CString& rSocketAddress, int nFlags = 0);
    virtual int ReceiveFrom(void* lpBuf, int nBufLen, SOCKADDR* pSocketAddress, int* pSockAddrLen, int nFlags = 0);
    virtual int Send(const void* lpBuf, int nBufLen, int nFlags = 0);
    virtual int SendTo(const void* lpBuf, int nBufLen, LPCTSTR lpSocketAddress, int nFlags = 0);
    virtual int SendTo(const void* lpBuf, int nBufLen, SOCKADDR* pSocketAddress, int nFlags = 0);
    static SOCKADDR Ipv4StringToData(LPCTSTR lpAddress);
    static BOOL Ipv4StringToData(LPCTSTR lpAddress, SOCKADDR& addrData);
    static CString Ipv4DataToString(SOCKADDR& addrIn, BOOL bWithPort);
    static BOOL Ipv4DataToString(SOCKADDR& addrIn, CString& strAddr, BOOL bWithPort);
    static int GetLastError();

    virtual bool OnWorkThreadProc(WNWorkThread* objThread, unsigned int& uStep);
    virtual unsigned int OnWorkThreadNeedSleep(WNWorkThread* objThread);

protected:
    virtual BOOL CreateSocketWindow();
    virtual BOOL DestroySocketWindow();
    virtual LRESULT InternalWindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
    LRESULT ACWindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
    static DWORD WINAPI RunLoopThreadProc(LPVOID lpParameter);
    DWORD InternalRunLoopThreadProc();
    //当前socket可读(或可以进行accept操作)
    virtual void OnObserverRead(IWNSocketObserver* observer);
    //当前socket错误
    virtual void OnObserverError(IWNSocketObserver* observer);
    virtual BOOL DoPorcessTcpDataRead();
    virtual BOOL DoProcessUdpDataRead();
    virtual BOOL DoProcessObserverRead(IWNSocketObserver* observer);
    virtual BOOL DoProcessObserverError(IWNSocketObserver* observer);
#ifndef WIN32
    friend LRESULT CALLBACK WNCommonSocketWindowProcedure (HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
#endif
public:
    HWND mhwnd; //socket相关窗口，在非当前线程中创建socket时有效
    DWORD mdwWindowThreadId; //窗口线程id
    //BOOL mbHasWindowMessage; //表示是否有窗口消息未处理/
    HANDLE mThreadHandle; //线程句柄
    DWORD mdwThreadId; //线程id
    WNWorkThread* mpRunLoopThread; //工作线程
    UINT muRunLoopThreadSleepTime; //工作线程睡眠时间,毫秒
    INT miSocketInitProtocalFamily; //初始化用的socket协议族，默认为AF_INET
    INT miSocketInitType; //初始化用的socket类型，默认为SOCK_STREAM
    INT miSocketInitProtocal; //初始化用的协议，默认为0
    BOOL mbExitThread; //退出线程标志位
    BOOL mbIsThreadRunning; //表示线程是否正在运行
    WNCommonSocketDelegate* mpCommonSocketDelegate; //托管对象
    CString mstrSocketIdentity; //socket标识符
    void* mUserInfo; //用户信息
    ACWinProc* mpACWinProc; //窗口处理函数回调
#ifdef WIN32
    UINT muMsgOnWNObserverRead; //检测到socket可读
    UINT muMsgOnWNObserverError; //检测到socket错误
    UINT muMsgNeedDestroyWindow; //需要销毁窗口消消息
#endif
    char* mpReceiveBuffer; //接收缓冲区
    char* mpReceiveBufferPos; //当前接收位置
    UINT muAvailableReceiveLen; //接收缓冲区可用大小
    volatile BOOL mbOnRead;
    volatile BOOL mbOnError;
    volatile IWNSocketObserver* mpReadObserver;
    volatile IWNSocketObserver* mpErrorObserver;
};


#endif
