/*utf8解析行 Don't remove or modify this first line!*/
#include "WNCommonSocket.h"
#include "WNCStringList.h"
#include "WNSocketObserverManager.h"
#include "stdio.h"
#include <stdlib.h>
#include <netinet/tcp.h> 
//#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/ioctl.h>
#include <sstream>
#include <errno.h>

DWORD mdwMainThreadId = 0;

#ifndef WIN32
#define ioctlsocket ioctl
#endif

WNCommonSocket::WNCommonSocket(void)
    :mhwnd(NULL)
    //,mbHasWindowMessage(FALSE)
    ,mThreadHandle(NULL)
    ,mdwThreadId(0)
    ,mpRunLoopThread(NULL)
    ,muRunLoopThreadSleepTime(1)
    ,miSocketInitProtocalFamily(AF_INET)
    ,miSocketInitType(SOCK_STREAM)
    ,miSocketInitProtocal(0)
    ,mbExitThread(FALSE)
    ,mbIsThreadRunning(FALSE)
    ,mpCommonSocketDelegate(NULL)
    ,mstrSocketIdentity(_T(""))
    ,mUserInfo(NULL)
    ,mpACWinProc(NULL)
    ,mpReceiveBuffer(NULL)
    ,mpReceiveBufferPos(NULL)
    ,muAvailableReceiveLen(0)
    ,mbOnRead(FALSE)
    ,mbOnError(FALSE)
    ,mpReadObserver(NULL)
    ,mpErrorObserver(NULL)
{
#ifdef WIN32
    muMsgOnWNObserverRead = ::RegisterWindowMessage(_T("OnWNObserverRead"));
    muMsgOnWNObserverError = ::RegisterWindowMessage(_T("OnWNObserverError"));
    muMsgNeedDestroyWindow = ::RegisterWindowMessage(_T("NeedDestroyWindow"));
#endif
}


WNCommonSocket::~WNCommonSocket(void)
{
    if (mSocket != INVALID_SOCKET)
        CloseSocket();
}

BOOL WNCommonSocket::CreateSocket( )
{
    if (mSocket != INVALID_SOCKET)
    {
        //必须首先关闭socket
        return FALSE;
    }
    if (!miSocketInitProtocal)
    {
        if (miSocketInitType == SOCK_STREAM)
        {
            miSocketInitProtocal = IPPROTO_TCP;
        }
        if (miSocketInitType == SOCK_DGRAM)
        {
            miSocketInitProtocal = IPPROTO_UDP;
        }
    }
    mSocket = ::socket(miSocketInitProtocalFamily, miSocketInitType, miSocketInitProtocal);
    if (mSocket != INVALID_SOCKET)
    {
        if (miSocketInitType == SOCK_STREAM)
        {
            int iValue = 1;
            int iLen = sizeof(iValue);
            SetSockOpt(TCP_NODELAY, &iValue, iLen, IPPROTO_TCP);
        }
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

BOOL WNCommonSocket::SetSocketAddress( LPCTSTR lpAddress )
{
    SOCKADDR addrIn;
    memset(&addrIn, 0, sizeof(addrIn));
    Ipv4StringToData(lpAddress, addrIn);
    if (!::bind(mSocket, &addrIn, sizeof(addrIn)))
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

BOOL WNCommonSocket::SetSocketAddress( LPCTSTR lpAddress, UINT uPort )
{
    SOCKADDR addrIn;
    memset(&addrIn, 0, sizeof(addrIn));
    Ipv4StringToData(lpAddress, addrIn);
    ((SOCKADDR_IN*)&addrIn)->sin_port = htons(uPort);
    if (!::bind(mSocket, &addrIn, sizeof(addrIn)))
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

BOOL WNCommonSocket::SetSocketAddress( SOCKADDR* pSockAddr )
{
    if (!::bind(mSocket, pSockAddr, sizeof(*pSockAddr)))
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

BOOL WNCommonSocket::EnterObserverLoop( BOOL bInNewThread )
{
    if (mSocket == INVALID_SOCKET)
    {
        //无效socket
        return FALSE;
    }
    if (mhwnd || mpRunLoopThread)
    {
        //已经进入监控循环
        return FALSE;
    }
    if (bInNewThread)
    {
        //创建新线程循环，在新线程循环中处理socket事件
        mbOnRead = FALSE;
        mbOnError = FALSE;
        mpReadObserver = NULL;
        mpErrorObserver = NULL;
        mpObserverTargetDelegate = this;
        WNSocketObserverManager::AddSocket(this);
        mpRunLoopThread = new WNWorkThread;
        mpRunLoopThread->Delegate() = this;
        mpRunLoopThread->StartWork();
        if (mpRunLoopThread->ThreadId())
        {
            return TRUE;
        }
        else
        {
            return FALSE;
        }
    }
    else
    {
        //在当前线程循环中处理socket事件，创建一个窗口
        if (!mhwnd)
        {
            CreateSocketWindow();
        }
        if (mhwnd)
        {
            //进入循环
            mpObserverTargetDelegate = this;
            if (!WNSocketObserverManager::AddSocket(this))
            {
                DestroySocketWindow();
                return FALSE;
            }
            return TRUE;
        }
        else
        {
            return FALSE;
        }
    }
}


BOOL WNCommonSocket::ExitObserverLoop()
{
    //Lock();
#ifdef WIN32
    if (mhwnd)
    {
        //TRACE("mdwWindowThreadId != ::GetCurrentThreadId()1\n");
        //有窗口，销毁窗口
        if (mdwWindowThreadId != ::GetCurrentThreadId())
        {
            //TRACE("mdwWindowThreadId != ::GetCurrentThreadId()2\n");

            //Unlock();
            //TRACE("mdwWindowThreadId != ::GetCurrentThreadId()3\n");

            ::PostMessage(mhwnd, muMsgNeedDestroyWindow, (WPARAM)&mhwnd, NULL);
            DWORD dwTime = ::GetTickCount();
            while (mhwnd && (::GetTickCount() - dwTime < 3000))
            {
                ::Sleep(10);
            }
            if (mhwnd)
            {
                DestroySocketWindow();
            }
            //TRACE("mdwWindowThreadId != ::GetCurrentThreadId()4\n");

            //Lock();
            //TRACE("WNCommonSocket::ExitObserverLooop Lock()\n");
        }
        else
        {
            DestroySocketWindow();
        }
    }
#endif
    if (!mpRunLoopThread)
    {
        return TRUE;
    }
    if (!mpRunLoopThread->ThreadId())
    {
        return TRUE;
    }
    WNSocketObserverManager::RemoveSocket(this);
    mpRunLoopThread->ResetFlag() = TRF_DeleteInstance;
    mpRunLoopThread->EndWork();
    mpRunLoopThread = NULL;
    return TRUE;
}


void WNCommonSocket::CloseSocket()
{
    ExitObserverLoop();
    mpCommonSocketDelegate = NULL;
    Lock();
    if (mSocket != INVALID_SOCKET)
    {
        ::shutdown(mSocket, SD_BOTH);
        ::close(mSocket);
        mSocket = INVALID_SOCKET;
        mSocketState = SS_None;
    }
    Unlock();

}

BOOL WNCommonSocket::AcceptSocket(WNCommonSocket* pNewSocket, SOCKADDR* pSockAddr /* = NULL */, int* pSockAddrLen /* = NULL */)
{
    Lock();
    SOCKET sockAccept = ::accept(mSocket, pSockAddr, pSockAddrLen);
    if (sockAccept != INVALID_SOCKET)
    {
        pNewSocket->mSocket = sockAccept;
        Unlock();
        return TRUE;
    }
    else
    {
        Unlock();
        return FALSE;
    }
}

BOOL WNCommonSocket::AcceptSocket( WNCommonSocket& newSocket, CString* pstrSockAddr /*= NULL*/, int* pSockAddrLen /*= NULL*/ )
{
    SOCKADDR sockAddr;
    memset(&sockAddr, 0, sizeof(sockAddr));
    int iSockAddrLen = 0;
    BOOL bRet = AcceptSocket(&newSocket, &sockAddr, &iSockAddrLen);
    if (pstrSockAddr)
    {
        Ipv4DataToString(sockAddr, *pstrSockAddr, TRUE);
    }
    if (pSockAddrLen)
    {
        *pSockAddrLen = iSockAddrLen;
    }
    return bRet;
}

BOOL WNCommonSocket::ConnectSocket( LPCTSTR lpszHostAddress )
{
    SOCKADDR hostAddress;
    memset(&hostAddress, 0, sizeof(hostAddress));
    Ipv4StringToData(lpszHostAddress, hostAddress);
    return ConnectSocket(&hostAddress);
}

BOOL WNCommonSocket::ConnectSocket( SOCKADDR* pHostAddress )
{
    Lock();
    if (::connect(mSocket, pHostAddress, sizeof(*pHostAddress)) != SOCKET_ERROR)
    {
        Unlock();
        return TRUE;
    }
    else
    {
        Unlock();
        int iError = GetLastError();
        return FALSE;
    }
}

BOOL WNCommonSocket::IOCtl( long lCommand, DWORD* lpArgument )
{
    Lock();
    if (SOCKET_ERROR != ::ioctlsocket(mSocket, lCommand, lpArgument))
    {
        Unlock();
        return TRUE;
    }
    else
    {
        Unlock();
        return FALSE;
    }
}

BOOL WNCommonSocket::SetSockOpt( int nOptionName, const void* lpOptionValue, int nOptionLen, int nLevel /*= SOL_SOCKET*/ )
{
    Lock();
    if (::setsockopt(mSocket, nLevel, nOptionName, (const char*)lpOptionValue, nOptionLen) != SOCKET_ERROR)
    {
        Unlock();
        return TRUE;
    }
    else
    {
        Unlock();
        return FALSE;
    }
}

BOOL WNCommonSocket::GetSockOpt( int nOptionName, void* lpOptionValue,int* lpOptionLen, int nLevel /*= SOL_SOCKET*/ )
{
    Lock();
    if (::getsockopt(mSocket, nLevel, nOptionName, (char*)lpOptionValue, lpOptionLen) != SOCKET_ERROR)
    {
        Unlock();
        return TRUE;
    }
    else
    {
        Unlock();
        return FALSE;
    }
}

BOOL WNCommonSocket::Listen( int nConnectionBacklog )
{
    if (mSocketState == SS_Listening)
    {
        return TRUE;
    }
    Lock();
    if (::listen(mSocket, nConnectionBacklog) != SOCKET_ERROR)
    {
        //设置当前socket状态
        mSocketState = SS_Listening;
        Unlock();
        return TRUE;
    }
    else
    {
        Unlock();
        return FALSE;
    }
}

BOOL WNCommonSocket::GetPeerName( CString& strIp, UINT& uPort )
{
    SOCKADDR addr;
    memset(&addr, 0, sizeof(addr));
    int iLen = sizeof(addr);
    int iRet = GetPeerName(&addr, &iLen);
    if (iRet != SOCKET_ERROR)
    {
        uPort = ntohs(((SOCKADDR_IN*)&addr)->sin_port);
        Ipv4DataToString(addr, strIp, FALSE);
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

BOOL WNCommonSocket::GetPeerName( SOCKADDR* lpSockAddr, int* lpSockAddrLen )
{
    Lock();
    int iRet = ::getpeername(mSocket, lpSockAddr, lpSockAddrLen);
    Unlock();
    if (iRet != SOCKET_ERROR)
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

BOOL WNCommonSocket::GetSockName( CString& strIp, UINT& uPort )
{
    SOCKADDR addr;
    memset(&addr, 0, sizeof(addr));
    int iLen = sizeof(addr);
    int iRet = GetSockName(&addr, &iLen);
    if (iRet != SOCKET_ERROR)
    {
        uPort = ntohs(((SOCKADDR_IN*)&addr)->sin_port);
        Ipv4DataToString(addr, strIp, FALSE);
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

BOOL WNCommonSocket::GetSockName( SOCKADDR* lpSockAddr, int* lpSockAddrLen )
{
    Lock();
    int iRet = ::getsockname(mSocket, lpSockAddr, lpSockAddrLen);
    Unlock();
    if (iRet != SOCKET_ERROR)
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}


void WNCommonSocket::SetReceiveBuffer( void* pBuffer, UINT uBufferLen )
{
    mpReceiveBuffer = (char*)pBuffer;
    mpReceiveBufferPos = mpReceiveBuffer;
    muAvailableReceiveLen = uBufferLen;
}


DWORD WNCommonSocket::ReceivedDataLen()
{
    Lock();
    DWORD dwLen = 0;
    ::ioctlsocket(mSocket, FIONREAD, &dwLen);
    Unlock();
    return dwLen;
}

int WNCommonSocket::Receive( void* lpBuf, int nBufLen, int nFlags /*= 0*/ )
{
    Lock();
    int iRet = ::recv(mSocket, (char*)lpBuf, nBufLen, nFlags);
    //检查是否需要进入runloop
    if ((iRet > 0) && !mpObserverTargetDelegate)
    {
        if (mhwnd || mpRunLoopThread)
        {
            mpObserverTargetDelegate = this;
        }
    }
    Unlock();
    return iRet;
}

int WNCommonSocket::ReceiveFrom( void* lpBuf, int nBufLen, CString& rSocketAddress, int nFlags /*= 0*/ )
{
    SOCKADDR sockAddr;
    memset(&sockAddr, 0, sizeof(sockAddr));
    int iSockAddrLen = sizeof(sockAddr);
    int iRet = ReceiveFrom(lpBuf, nBufLen, &sockAddr, &iSockAddrLen, nFlags);
    if (iRet != SOCKET_ERROR)
    {
        Ipv4DataToString(sockAddr, rSocketAddress, TRUE);
    }
    return iRet;
}

int WNCommonSocket::ReceiveFrom(void* lpBuf, int nBufLen, SOCKADDR* pSocketAddress, int* pSockAddrLen, int nFlags /* = 0 */)
{
    if (mSocket != INVALID_SOCKET)
    {
        Lock();
        int iRet = ::recvfrom(mSocket, (char*)lpBuf, nBufLen, nFlags, pSocketAddress, pSockAddrLen);
        //检查是否需要进入runloop
        if ((iRet > 0) && !mpObserverTargetDelegate)
        {
            if (mhwnd || mpRunLoopThread)
            {
                mpObserverTargetDelegate = this;
            }
        }
        Unlock();
        return iRet;
    }
    else
    {
        return 0;
    }
}

int WNCommonSocket::Send( const void* lpBuf, int nBufLen, int nFlags /*= 0*/ )
{
    Lock();
    if (mSocket != INVALID_SOCKET)
    {
        int iRet = ::send(mSocket, (const char*)lpBuf, nBufLen, nFlags);
        Unlock();
        return iRet;
    }
    else
    {
        Unlock();
        return 0;
    }
}

int WNCommonSocket::SendTo( const void* lpBuf, int nBufLen, LPCTSTR lpSocketAddress, int nFlags /*= 0*/ )
{
    SOCKADDR addr = Ipv4StringToData(lpSocketAddress);
    return SendTo(lpBuf, nBufLen, &addr, nFlags);
}

int WNCommonSocket::SendTo(const void* lpBuf, int nBufLen, SOCKADDR* pSocketAddress, int nFlags /*= 0*/)
{
    if (mSocket != INVALID_SOCKET)
    {
        Lock();
        int iRet = ::sendto(mSocket, (const char*)lpBuf, nBufLen, nFlags, pSocketAddress, sizeof(*pSocketAddress));
        Unlock();
        return iRet;
    }
    else
    {
        return 0;
    }
}

#ifdef WIN32
//通过一个地址取模块句柄    
HMODULE ModuleHandleByAddr(const void* ptrAddr)   
{   
    MEMORY_BASIC_INFORMATION info;   
    ::VirtualQuery(ptrAddr, &info, sizeof(info));   
    return (HMODULE)info.AllocationBase;   
}   

//获得当前模块句柄 
HMODULE ThisModuleHandle()
{   
    static HMODULE sInstance = ModuleHandleByAddr((void*)&ThisModuleHandle);
    return sInstance;   
} 


LRESULT CALLBACK WNCommonSocketWindowProcedure (HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    static UINT uMsgOnWNObserverRead = ::RegisterWindowMessage(_T("OnWNObserverRead"));
    static UINT uMsgOnWNObserverError = ::RegisterWindowMessage(_T("OnWNObserverError"));
    static UINT uMsgNeedDestroy = ::RegisterWindowMessage(_T("NeedDestroyWindow"));

    //__try
    {
        if (uMsg == uMsgNeedDestroy)
        {
            ::DestroyWindow(hwnd);
            *((HWND*)(wParam)) = NULL;
            return 0;
        }
        else if (uMsg == uMsgOnWNObserverRead)
        {
            return ((WNCommonSocket*)lParam)->DoProcessObserverRead((IWNSocketObserver*)wParam);
        }
        else if (uMsg == uMsgOnWNObserverError)
        {
            return ((WNCommonSocket*)lParam)->DoProcessObserverError((IWNSocketObserver*)wParam);
        }
        else
        {
            return ::DefWindowProc(hwnd, uMsg, wParam, lParam);
        }
    }
    //__except(EXCEPTION_EXECUTE_HANDLER)
    {
        return 0;
    }
}

#endif

//创建当前socket窗口
BOOL WNCommonSocket::CreateSocketWindow()
{
#ifdef WIN32
    if (mhwnd)
    {
        return FALSE;
    }
    static BOOL bHasRegister = FALSE;
    static LPCTSTR lpClassName = _T("WNCommonSocketWindow");

    //检查是否需要进行窗口注册
    if (!bHasRegister)
    {
        //需要注册窗口
        WNDCLASSEX wcex = { 0 };
        //WNDCLASSEX 的大小。我们可以用sizeof（WNDCLASSEX）来获得准确的值。
        wcex.cbSize = sizeof(WNDCLASSEX);
        //从这个窗口类派生的窗口具有的风格。您可以用“or”操作符来把几个风格或到一起。
        wcex.style = CS_HREDRAW | CS_VREDRAW;
        //窗口处理函数的指针。
        wcex.lpfnWndProc = &WNCommonSocketWindowProcedure;
        //指定紧跟在窗口类结构后的附加字节数。
        wcex.cbClsExtra = 0;
        //指定紧跟在窗口事例后的附加字节数。如果一个应用程序在资源中用CLASS伪指令注册一个对话框类时，则必须把这个成员设成DLGWINDOWEXTRA。
        wcex.cbWndExtra = 0;
        //本模块的事例句柄。
        wcex.hInstance = ThisModuleHandle();
        //图标的句柄。
        wcex.hIcon = NULL;
        //和窗口类关联的小图标。如果该值为NULL。则把hIcon中的图标转换成大小合适的小图标。
        wcex.hIconSm = NULL;
        //光标的句柄。
        wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
        //背景画刷的句柄。
        wcex.hbrBackground = ::CreateSolidBrush(RGB(236,233,216));
        //指向菜单的指针。
        wcex.lpszMenuName = NULL;
        //指向类名称的指针。
        wcex.lpszClassName = lpClassName;

        // 注册窗体类，如果失败退出
        if (!::RegisterClassEx (&wcex))
        {
            return FALSE;
        }
        else
        {
            //记录注册结果
            bHasRegister = TRUE;
        }
    }

    //创建窗口
    mhwnd = ::CreateWindowEx (
        WS_EX_APPWINDOW, 
        lpClassName,           /* 类名 */
        lpClassName,          /* 标题 */
        WS_OVERLAPPEDWINDOW, /* 窗体样式 */
        CW_USEDEFAULT,       /* X坐标 */
        CW_USEDEFAULT,       /* Y坐标 */
        100,                 /* 宽 */
        100,                 /* 长 */
        HWND_DESKTOP,        /* The window is a child-window to desktop */
        NULL,                /* No menu */
        ThisModuleHandle(),       /* Program Instance handler */
        NULL                 /* No Window Creation data */
        );
    if (!mhwnd)
    {
        //创建窗口失败
        return FALSE;
    }
    ////设置窗口处理函数
    //if (mpACWinProc)
    //{
    //	delete mpACWinProc;
    //}
    //mpACWinProc = new ACWinProc;
    //mpACWinProc->Assign(this, &WNCommonSocket::ACWindowProc);
    //WNDPROC lpWinProc = *mpACWinProc;
    ////已经知道旧的消息处理函数是DefWindowProc，所以无需保存
    //::SetWindowLongPtr(mhwnd, GWLP_WNDPROC, reinterpret_cast<LONG>(lpWinProc));
    mdwWindowThreadId = ::GetCurrentThreadId();
#endif
    return TRUE;
}


BOOL WNCommonSocket::DestroySocketWindow()
{
#ifdef WIN32
    if (mhwnd)
    {
        //::SetWindowLongPtr(mhwnd, GWLP_WNDPROC, reinterpret_cast<LONG>(&::DefWindowProc));
        ::DestroyWindow(mhwnd);
        mhwnd = NULL;
    }
#endif
    return TRUE;
}


LRESULT WNCommonSocket::InternalWindowProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
#ifdef WIN32
    // 	mbHasWindowMessage = FALSE;
    // 	if (mSocketState == SS_Closing)
    // 	{
    // 		return ::DefWindowProc(hwnd, uMsg, wParam, lParam);
    // 	}
    if (uMsg == muMsgOnWNObserverRead)
    {
        return DoProcessObserverRead((IWNSocketObserver*)wParam);
    }
    else if (uMsg == muMsgOnWNObserverError)
    {
        return DoProcessObserverError((IWNSocketObserver*)wParam);
    }
    else if (uMsg == muMsgNeedDestroyWindow)
    {
        DestroySocketWindow();
    }
    else
    {
        return ::DefWindowProc(hwnd, uMsg, wParam, lParam);
    }
#endif
    return 0;
}

LRESULT WNCommonSocket::ACWindowProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
    return InternalWindowProc(hwnd, uMsg, wParam, lParam);
}

DWORD WINAPI WNCommonSocket::RunLoopThreadProc( LPVOID lpParameter )
{
    WNCommonSocket* pSocket = (WNCommonSocket*)lpParameter;
    return pSocket->InternalRunLoopThreadProc();
}

DWORD WNCommonSocket::InternalRunLoopThreadProc()
{
#ifdef WIN32
    mbIsThreadRunning = TRUE;
    //首先进入循环
    mpObserverTargetDelegate = this;
    CString strOut;
    strOut.Format(_T("WNCommonSocket::InternalRunLoopThreadProc begin %d"), this);
    //OutputDebugString(strOut);
    CString strSelf = mstrSocketIdentity;
    //创建消息队列，等待退出
    MSG msg;
    ::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);
    if (!WNSocketObserverManager::AddSocket(this))
    {
        return FALSE;
    }
    while (!mbExitThread)
    {
        while (::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
        {
            if (!msg.hwnd && (msg.message == muMsgOnWNObserverRead))
            {
                ((WNCommonSocket*)msg.lParam)->DoProcessObserverRead((IWNSocketObserver*)msg.wParam);
            }
            else if (!msg.hwnd && (msg.message == muMsgOnWNObserverError))
            {
                ((WNCommonSocket*)msg.lParam)->DoProcessObserverError((IWNSocketObserver*)msg.wParam);
            }
            else
            {
                ::TranslateMessage(&msg);
                ::DispatchMessage(&msg);
            }
        }
        UINT uSleepTime = 1;
        if (mpCommonSocketDelegate)
        {
            mpCommonSocketDelegate->OnCommonSocketThreadProc(&uSleepTime);
        }
        if (!mbExitThread && uSleepTime)
        {
            ::Sleep(uSleepTime);
        }

        //Sleep(5);
    }
    //strOut.Format(_T("WNCommonSocket::InternalRunLoopThreadProc end %d"), this);
    //OutputDebugString(strOut);
    while (::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
    {

    }
    mbIsThreadRunning = FALSE;
#endif
    return 0;
}

SOCKADDR WNCommonSocket::Ipv4StringToData( LPCTSTR lpAddress )
{
    SOCKADDR addrData;
    memset(&addrData, 0, sizeof(addrData));
    Ipv4StringToData(lpAddress, addrData);
    return addrData;
}

BOOL WNCommonSocket::Ipv4StringToData( LPCTSTR lpAddress, SOCKADDR& addrData )
{
    SOCKADDR_IN& AddrIn = (SOCKADDR_IN&)addrData;
    if (!lpAddress)
    {
        //地址不能为空
        return FALSE;
    }
    WNCStringList lstAdrees;
    WNCStringList lstIp;
    lstAdrees.CreateList(lpAddress, _T(":"));
    if (lstAdrees.ListCount() == 1)
    {
        //只有ip
        lstIp.CreateList(lpAddress, _T("."));
    }
    else if (lstAdrees.ListCount() == 2)
    {
        //有ip以及端口
        lstIp.CreateList(lstAdrees.BeginData().c_str(), _T("."));
    }
    else
    {
        //非法ip，无法转换
        return FALSE;
    }
    if (lstIp.ListCount() != 4)
    {
        //非法ip，无法转换
        return FALSE;
    }

    AddrIn.sin_family = AF_INET;
    
    //如果不需要设置端口，默认为0
    if (lstAdrees.ListCount() == 2)
    {
        //需要设置端口
        AddrIn.sin_port = htons((USHORT)_tcstoul(lstAdrees.EndData().c_str(), NULL, 10));
    }
    unsigned char* pCharAddr = (unsigned char*)(&(AddrIn.sin_addr));
    pCharAddr += 3;
    for (lstIp.MoveEnd(); lstIp.NotHead(); lstIp.MovePrev())
    {
        *pCharAddr = (unsigned char)_tcstoul(lstIp.CurrentData().c_str(), NULL, 10);
        pCharAddr--;
    }
    //char* pch = inet_ntoa(AddrIn.sin_addr);
    //OutputDebugStringA(inet_ntoa(AddrIn.sin_addr));
    return TRUE;
}

CString WNCommonSocket::Ipv4DataToString( SOCKADDR& addrIn, BOOL bWithPort )
{
    SOCKADDR_IN& AddrIn = (SOCKADDR_IN&)addrIn;
    unsigned char* pCharAddr = (unsigned char*)(&(AddrIn.sin_addr));
    CString strRet = _T("");
    Ipv4DataToString(addrIn, strRet, bWithPort);
    return strRet;
}

BOOL WNCommonSocket::Ipv4DataToString( SOCKADDR& addrIn, CString& strAddr, BOOL bWithPort )
{
    SOCKADDR_IN& AddrIn = (SOCKADDR_IN&)addrIn;
    unsigned char* pCharAddr = (unsigned char*)(&(AddrIn.sin_addr));
    if (bWithPort)
    {
        ostringstream  strKeystream;

        strKeystream << (int)pCharAddr[0] << "." << (int)pCharAddr[1] << "." << (int)pCharAddr[2] << "." <<  (int)pCharAddr[3] << ":" << (int)ntohs(AddrIn.sin_port);
        //Addr.Format(("%d.%d.%d.%d:%u"), pCharAddr[0], pCharAddr[1], pCharAddr[2], pCharAddr[3], ntohs(AddrIn.sin_port));
        strAddr = strKeystream.str();
    }
    else
    {
        //Addr.Format(("%d.%d.%d.%d"), pCharAddr[0], pCharAddr[1], pCharAddr[2], pCharAddr[3]);
        ostringstream  strKeystream;

        strKeystream << (int)pCharAddr[0] << "." << (int)pCharAddr[1] << "." << (int)pCharAddr[2] << "." <<  (int)pCharAddr[3];
        //Addr.Format(("%d.%d.%d.%d:%u"), pCharAddr[0], pCharAddr[1], pCharAddr[2], pCharAddr[3], ntohs(AddrIn.sin_port));
        strAddr = strKeystream.str();
    }
    return TRUE;
}

int WNCommonSocket::GetLastError()
{
    return errno;
}


bool WNCommonSocket::OnWorkThreadProc( WNWorkThread* objThread, unsigned int& uStep )
{
    if (objThread != this->mpRunLoopThread)
    {
        return WN_WORK_THREAD_EXIT;
    }
    if (mbOnRead)
    {
        mbOnRead = FALSE;
        IWNSocketObserver* pObserver = (IWNSocketObserver*)mpReadObserver;
        DoProcessObserverRead(pObserver);
        muRunLoopThreadSleepTime = 0;
    }
    else if (mbOnError)
    {
        mbOnError = FALSE;
        IWNSocketObserver* pObserver = (IWNSocketObserver*)mpErrorObserver;
        DoProcessObserverError(pObserver);
        muRunLoopThreadSleepTime = 0;
    }
    else
    {
        UINT uSleepTime = 5;
        if (mpCommonSocketDelegate)
        {
            mpCommonSocketDelegate->OnCommonSocketThreadProc(&uSleepTime);
        }
        if (uSleepTime)
        {
            muRunLoopThreadSleepTime = uSleepTime;
        }
    }
    return WN_WORK_THREAD_CONTINUE;
}

unsigned int WNCommonSocket::OnWorkThreadNeedSleep( WNWorkThread* objThread )
{
    return muRunLoopThreadSleepTime;
}

void WNCommonSocket::OnObserverRead( IWNSocketObserver* observer )
{
#ifdef WIN32
    if (mhwnd)
    {
        //mbHasWindowMessage = TRUE;
        ::PostMessage(mhwnd, muMsgOnWNObserverRead, (WPARAM)observer, (LPARAM)this);
    }
    else if (mdwThreadId)
    {
        //DoPorcessTcpDataRead();
        ::PostThreadMessage(mdwThreadId, muMsgOnWNObserverRead, (WPARAM)observer, (LPARAM)this);
    }
#endif
        mbOnRead = TRUE;
        mpReadObserver = observer;
}

void WNCommonSocket::OnObserverError( IWNSocketObserver* observer )
{
#ifdef WIN32
    if (mhwnd)
    {
        ::PostMessage(mhwnd, muMsgOnWNObserverError, (WPARAM)observer, (LPARAM)this);
    }
    else if (mdwThreadId)
    {
        ::PostThreadMessage(mdwThreadId, muMsgOnWNObserverError, (WPARAM)observer, (LPARAM)this);
    }
#endif
    mbOnError = TRUE;
    mpErrorObserver = observer;
}

#define RECEIV_BUF_LEN (mpReceiveBufferPos + muAvailableReceiveLen - mpReceiveBuffer)


BOOL WNCommonSocket::DoPorcessTcpDataRead()
{
    DWORD dwUnreadLen = 0;
    ::ioctlsocket(mSocket, FIONREAD, &dwUnreadLen);

    int iRet = 0;
    while (true)
    {
        if (!dwUnreadLen)
        {
            //检查是否需要进入runloop
            if (!mpObserverTargetDelegate)
            {
                if (mhwnd || mpRunLoopThread)
                {
                    mpObserverTargetDelegate = this;
                }
            }
            break;
        }
        if (!muAvailableReceiveLen)
        {
            if (mpCommonSocketDelegate)
            {
                mpCommonSocketDelegate->OnCommonSocketReceive(this, dwUnreadLen);
            }
            break;
        }
        else if (muAvailableReceiveLen <= dwUnreadLen)
        {
            iRet = ::recv(mSocket, mpReceiveBufferPos, muAvailableReceiveLen, 0);
            if (iRet != (int)muAvailableReceiveLen)
            {
                return false;
            }
            dwUnreadLen -= iRet;
            muAvailableReceiveLen -= iRet;
            mpReceiveBufferPos += iRet;
            if (iRet == 0)
            {
                //socket已关闭
                if (mpCommonSocketDelegate)
                {
                    mpCommonSocketDelegate->OnCommonSocketClose(this);
                }
                return true;
            }
            else
            {
                //通知缓冲区已满
                if (mpCommonSocketDelegate)
                {
                    mpCommonSocketDelegate->OnCommonSocketRecvBufferFulled(this, mpReceiveBuffer, RECEIV_BUF_LEN, dwUnreadLen);
                }
            }
        }
        else
        {
            iRet = ::recv(mSocket, mpReceiveBufferPos, dwUnreadLen, 0);
            if (iRet != (int)dwUnreadLen)
            {
                return false;
            }
            dwUnreadLen -= iRet;
            muAvailableReceiveLen -= iRet;
            mpReceiveBufferPos += iRet;
            if (iRet == 0)
            {
                //socket已关闭
                if (mpCommonSocketDelegate)
                {
                    mpCommonSocketDelegate->OnCommonSocketClose(this);
                }
                return true;
            }
            //检查是否需要进入runloop
            if (!mpObserverTargetDelegate)
            {
                if (mhwnd || mpRunLoopThread)
                {
                    mpObserverTargetDelegate = this;
                }
            }
            break;
        }
    }
    return true;
}


BOOL WNCommonSocket::DoProcessUdpDataRead()
{
    DWORD dwUnreadLen = 0;
    ::ioctlsocket(mSocket, FIONREAD, &dwUnreadLen);
    while (dwUnreadLen)
    {
        if (mpCommonSocketDelegate)
        {
            mpCommonSocketDelegate->OnCommonSocketReceive(this, dwUnreadLen);
            ::ioctlsocket(mSocket, FIONREAD, &dwUnreadLen);
        }
        else
        {
            break;
        }
    }
    return true;
}

BOOL WNCommonSocket::DoProcessObserverRead( IWNSocketObserver* observer )
{
    if (!mpCommonSocketDelegate)
    {
        if (!mpObserverTargetDelegate)
        {
            mpObserverTargetDelegate = this;
        }
        return FALSE;
    }
    if (mSocketState == SS_Listening)
    {
        //监听状态，说明有socket请求连接
        if (mpCommonSocketDelegate)
        {
            mpCommonSocketDelegate->OnCommonSocketAccept(this);
        }
    }
    else
    {
        //非监听状态,首先检测是否关闭

        if (miSocketInitType == SOCK_DGRAM)
        {
            //有内容可读
            DoProcessUdpDataRead();
            return TRUE;
        }
        char buf[1] = { 0 };
        int iRet = 0;
        iRet = ::recv(mSocket, buf, 1, MSG_PEEK);
        if (iRet == 0)
        {
            //socket已关闭
            if (mpCommonSocketDelegate)
            {
                mpCommonSocketDelegate->OnCommonSocketClose(this);
            }
        }
        else if (iRet != SOCKET_ERROR)
        {
            //有内容可读
            if (miSocketInitType == SOCK_STREAM)
            {
                DoPorcessTcpDataRead();
            }
            else
            {
                DWORD dwUnreadLen = 0;
                ::ioctlsocket(mSocket, FIONREAD, &dwUnreadLen);
                if (mpCommonSocketDelegate)
                {
                    mpCommonSocketDelegate->OnCommonSocketReceive(this, dwUnreadLen);
                }
            }
        }
        else
        {
            //读取错误
            int iError = GetLastError();
            return FALSE;
        }
    }
    return TRUE;
}

BOOL WNCommonSocket::DoProcessObserverError( IWNSocketObserver* observer )
{
    if (!mpCommonSocketDelegate)
    {
        return FALSE;
    }
    mpCommonSocketDelegate->OnCommonSocketError(this, miObserverErrorCode);
    return TRUE;
}




