/*utf8解析行 Don't remove or modify this first line!*/
#ifdef __WINOS__
#include "StdAfx.h"
#endif
#include "WNCreticalSection.h"
#include "stdio.h"

class CreticalSectionAttr
{
public:
    pthread_mutexattr_t mattr;
public:
    CreticalSectionAttr()
    {
        pthread_mutexattr_init(&mattr);
        pthread_mutexattr_settype(&mattr, PTHREAD_MUTEX_RECURSIVE);
    }
    ~CreticalSectionAttr()
    {
        pthread_mutexattr_destroy(&mattr);
    }
    pthread_mutexattr_t* getAttr()
    {
        return &mattr;
    }
};

CreticalSectionAttr mCreticalSectionAttr;

WNCreticalSection::WNCreticalSection(void)
	:mpLocker(NULL)
{
	CreateLocker();
}


WNCreticalSection::~WNCreticalSection(void)
{
	DestroyLocker();
}

void WNCreticalSection::CreateLocker()
{
	if (!mpLocker)
	{
		mpLocker = new pthread_mutex_t;
        pthread_mutex_init(mpLocker, mCreticalSectionAttr.getAttr());
	}
	
}

void WNCreticalSection::DestroyLocker()
{
	if (mpLocker)
	{ 
		pthread_mutex_destroy(mpLocker); 
		delete mpLocker;
		mpLocker = NULL;
	}
}

bool WNCreticalSection::TryLock()
{
	if (mpLocker)
	{
		
		//pthread_mutex_lock(mpLocker); 		
		
		/*struct timespec lockwait = {0,50000000};
		int ret = pthread_mutex_timedlock(mpLocker,&lockwait);
		
		return (ret == 0) ? true : false;*/
		int ret = pthread_mutex_trylock(mpLocker);
		
		return (ret == 0) ? true : false;
	}
	else
	{
		//没有初始化锁，默认返回TRUE表示可以操作
		return true;
	}
	
 	return true;
}

bool WNCreticalSection::Lock()
{
	if (mpLocker)
	{
        while(pthread_mutex_lock(mpLocker))
        {
            printf("WNCreticalSection lock failed!");
        }
	}

	//没有初始化锁，默认返回TRUE表示可以操作
	return  true;
}

bool WNCreticalSection::Unlock()
{
	if (mpLocker)
	{
		
		pthread_mutex_unlock(mpLocker); 
		
	}

	return true;
}



WNCreticalSectionAutoLocker::WNCreticalSectionAutoLocker()
	:mpLocker(NULL)
	,mpLocking(NULL)
{

}

WNCreticalSectionAutoLocker::WNCreticalSectionAutoLocker(WNCreticalSection* pCreiticalSection, bool bLocker /* = TRUE */)
	:mpLocker(NULL)
	,mpLocking(NULL)
{
	mpLocker = pCreiticalSection;
	if (bLocker)
	{
		Lock();
	}
}

WNCreticalSectionAutoLocker::~WNCreticalSectionAutoLocker()
{
	if (mpLocker && mpLocking)
	{
		mpLocker->Unlock();
	}
	
}

bool WNCreticalSectionAutoLocker::TryLock()
{
	if (mpLocker)
	{
		if (mpLocking == mpLocker)
		{
			return true;
		}
		else if (!mpLocking)
		{
			if (mpLocker->TryLock())
			{
				mpLocking = mpLocker;
				return true;
			}
			else
			{
				mpLocking = NULL;
				return false;
			}
		}
		else if (mpLocker->TryLock())
		{
			mpLocking = mpLocker;
			return true;
		}
		else
		{
			mpLocking = NULL;
			return false;
		}
	}
	else
	{
		//未设置锁对象
		//默认为成功锁定
		return true;
	}
}

void WNCreticalSectionAutoLocker::Lock()
{
	if (mpLocker)
	{
		if (!mpLocking || (mpLocking != mpLocker))
		{
			mpLocker->Lock();
			mpLocking = mpLocker;
		}
	}
}

void WNCreticalSectionAutoLocker::Unlock()
{
	if (!mpLocker)
	{
		return;
	}
	if (mpLocking == mpLocker)
	{
		mpLocker->Unlock();
	}
	mpLocking = NULL;
	
}

