/*utf8解析行 Don't remove or modify this first line!*/
#include "stdafx.h"
#include "WNNetworkInfo.h"

WNAddrData::WNAddrData()
	:m_strAdapterName(_T(""))
	,m_strAdapterInfo(_T(""))
	,m_strIp(_T("0.0.0.0"))
	,m_uMacLen(0)
	,m_strVirtualMac(_T(""))
	,m_bIsVirtual(FALSE)
	,m_uType(0)
	,m_nIPCount(0)
{
	ZeroMemory(m_MacAddr, MAC_LENGTH);
}

WNAddrData::WNAddrData( const WNAddrData& data )
{
	m_strAdapterName = data.m_strAdapterName;
	m_strAdapterInfo = data.m_strAdapterInfo;
	m_strIp = data.m_strIp;
	m_uMacLen = data.m_uMacLen;
	m_strVirtualMac = data.m_strVirtualMac;
	m_bIsVirtual = data.m_bIsVirtual;
	m_uType = data.m_uType;
	CopyMemory(m_MacAddr, data.m_MacAddr, MAC_LENGTH);
}

CString WNAddrData::GetMacAddress()
{
	if (m_strVirtualMac != _T(""))
	{
		return m_strVirtualMac;
	}
	CString strRet = _T("");
	CString strCh = _T("");
	for (UINT i = 0; i < m_uMacLen; i++)
	{
		strCh.Format(_T("%02X"), m_MacAddr[i]);
		strRet += strCh;
	}
	return strRet;
}



WNAddrData& WNAddrData::operator=( const WNAddrData& data )
{
	if (this == &data)
	{
		return *this;
	}
	m_strAdapterName = data.m_strAdapterName;
	m_strAdapterInfo = data.m_strAdapterInfo;
	m_strIp = data.m_strIp;
	m_uMacLen = data.m_uMacLen;
	m_strVirtualMac = data.m_strVirtualMac;
	m_bIsVirtual = data.m_bIsVirtual;
	m_strBroadCastIp = data.m_strBroadCastIp;
	m_strSubnetMask  = data.m_strSubnetMask;
	m_uType = data.m_uType;
	m_dwStartIp = data.m_dwStartIp;
	m_dwEndIp = data.m_dwEndIp;
	m_dwAdapterIndex = data.m_dwAdapterIndex;
	m_nIPCount = data.m_nIPCount;

	for(int iIndex = 0; iIndex < m_nIPCount; ++iIndex)
		m_strIPList[iIndex] = data.m_strIPList[iIndex];

	CopyMemory(m_MacAddr, data.m_MacAddr, MAC_LENGTH);
	return *this;
}
WNNetworkInfo::WNNetworkInfo()
{
	ReInit();
}

VOID WNNetworkInfo::ReInit()
{
	WNAddrData macDatas[ADAPTER_COUNT_MAX];
	LONG lInsertCount = GetSystemMacInfo(macDatas);
	m_lCount = 0;
	//for (LONG j = 1; j < lInsertCount; j++)
	//{
	//    if (macDatas[j].m_uType != MIB_IF_TYPE_PPP)
	//    {
	//        m_MacData[m_lSystemIdCount] = macDatas[0];
	//        CopyMemory(m_MacData[m_lSystemIdCount].m_MacAddr, macDatas[j].m_MacAddr, MAC_LENGTH);
	//        m_MacData[m_lSystemIdCount].m_strIp = macDatas[j].m_strIp;
	//        m_lSystemIdCount++;
	//    }
	//}
	for (LONG i = 0; i < lInsertCount; i++)
	{
		if (macDatas->m_uType != MIB_IF_TYPE_PPP)
		{
			m_AddrData[m_lCount] = macDatas[i];
			m_lCount++;
		}
	}
	for (LONG i = 0; i < lInsertCount; i++)
	{
		if (macDatas->m_uType == MIB_IF_TYPE_PPP)
		{
			for (LONG j = 0; j < lInsertCount; j++)
			{
				if (macDatas[j].m_uType != MIB_IF_TYPE_PPP)
				{
					m_AddrData[m_lCount] = macDatas[i];
					CopyMemory(m_AddrData[m_lCount].m_MacAddr, macDatas[j].m_MacAddr, MAC_LENGTH);
					m_lCount++;
				}
			}
		}
	}
}


BOOL WNNetworkInfo::IsConnectedAdapter(DWORD dwIndex)
{
	MIB_IFROW ifRow;
	ZeroMemory(&ifRow, sizeof(ifRow));
	ifRow.dwIndex = dwIndex;
	DWORD dwRet = GetIfEntry(&ifRow);
	if (dwRet != NO_ERROR)
	{
		OutputDebugString(_T("GetIfEntry return is not NO_ERROR"));
		return FALSE;
	}

	if (ifRow.dwOperStatus != MIB_IF_OPER_STATUS_OPERATIONAL)
	{
		OutputDebugString(_T("ifRow.dwOperStatus != MIB_IF_OPER_STATUS_CONNECTED"));
		CString strOut;
		strOut.Format(_T("State is %d"), ifRow.dwOperStatus);
		OutputDebugString(strOut);
		return FALSE;
	}

	return TRUE;
}

//get system Ethernet adapters
LONG WNNetworkInfo::GetSystemMacInfo(WNAddrData* pAddrData)
{
	IP_ADAPTER_INFO ipAdapterInfo[ADAPTER_COUNT_MAX];
	ULONG uBufferSize = sizeof(IP_ADAPTER_INFO) * ADAPTER_COUNT_MAX;
	DWORD dwRet = GetAdaptersInfo(ipAdapterInfo, &uBufferSize);
	if (ERROR_SUCCESS != dwRet)
	{
		return FALSE;
	}
	//Add a virtual networkcard at first
	//pMacData->m_strAdapterName = _T("E Virtual NetworkCard");
	//pMacData->m_bIsVirtual = TRUE;
	//pMacData++;
	LONG lRet = 0;
	PIP_ADAPTER_INFO pInfo = ipAdapterInfo;
	PIP_ADDR_STRING pIpInfo = &(pInfo->IpAddressList);
	
	while (pInfo)
	{
		if (MIB_IF_TYPE_ETHERNET == pInfo->Type || MIB_IF_TYPE_PPP == pInfo->Type || TRUE)
		{
			if (IsConnectedAdapter(pInfo->Index) || MIB_IF_TYPE_PPP == pInfo->Type)
			{
				pAddrData->m_dwAdapterIndex = pInfo->Index;
				CopyMemory(pAddrData->m_MacAddr, pInfo->Address, pInfo->AddressLength);
				pAddrData->m_uMacLen = pInfo->AddressLength;
				LPTSTR pBuf = pAddrData->m_strAdapterInfo.GetBuffer(sizeof(pInfo->Description) * sizeof(TCHAR));
				//pMacData->m_strAdapterInfo.Format(_T("%s"), pInfo->Description);
				MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, pInfo->Description, -1, pBuf, sizeof(pInfo->Description));
				pAddrData->m_strAdapterInfo.ReleaseBuffer();

				pBuf = pAddrData->m_strAdapterName.GetBuffer(sizeof(pInfo->AdapterName) * sizeof(TCHAR));
				MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, pInfo->AdapterName, -1, pBuf, sizeof(pInfo->AdapterName));
				pAddrData->m_strAdapterName.ReleaseBuffer();

				pBuf = pAddrData->m_strIp.GetBuffer(sizeof(pIpInfo->IpAddress) * sizeof(TCHAR));
				MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, pIpInfo->IpAddress.String, -1, pBuf, sizeof(pIpInfo->IpAddress.String) * sizeof(TCHAR));
				pAddrData->m_strIp.ReleaseBuffer();

				pBuf = pAddrData->m_strSubnetMask.GetBuffer(sizeof(pIpInfo->IpMask) * sizeof(TCHAR));
				MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, pIpInfo->IpMask.String, -1, pBuf, sizeof(pIpInfo->IpMask.String) * sizeof(TCHAR));
				pAddrData->m_strSubnetMask.ReleaseBuffer();

				in_addr broadcast;
				broadcast.S_un.S_addr = (inet_addr( CT2A(pAddrData->m_strIp)) 
										& inet_addr( CT2A(pAddrData->m_strSubnetMask)))
										| (~inet_addr( CT2A(pAddrData->m_strSubnetMask)));
				pAddrData->m_strBroadCastIp = inet_ntoa(broadcast);

				pAddrData->m_dwStartIp = (ntohl(inet_addr( CT2A(pAddrData->m_strSubnetMask))) & ntohl(inet_addr( CT2A(pAddrData->m_strIp)))) + 1;
				pAddrData->m_dwEndIp = ntohl(inet_addr( CT2A(pAddrData->m_strBroadCastIp) )) - 1;

				if((pAddrData->m_dwEndIp - pAddrData->m_dwStartIp) > 1000)
				{
					pAddrData->m_dwEndIp = pAddrData->m_dwStartIp + 1000;
				}


				pAddrData->m_uType = pInfo->Type;
				OutputDebugStringV(pAddrData->m_strAdapterName);
				OutputDebugStringV(pAddrData->m_strAdapterInfo);
				OutputDebugStringV(pAddrData->GetMacAddress());
				OutputDebugStringV(pAddrData->m_strIp);

				if(!pAddrData->m_strIp.IsEmpty())
				{
					pAddrData->m_strIPList[pAddrData->m_nIPCount] = pAddrData->m_strIp;
				    ++pAddrData->m_nIPCount;
				}

				if (pIpInfo->Next)
				{
					pIpInfo = pIpInfo->Next;
				}
				else
				{
					pInfo = pInfo->Next;
					pIpInfo = &(pInfo->IpAddressList);
				}
				lRet++;
				pAddrData++;
			}
			else
			{
				pInfo = pInfo->Next;
				pIpInfo = &(pInfo->IpAddressList);
			}
		}
		else
		{
			pInfo = pInfo->Next;
			pIpInfo = &(pInfo->IpAddressList);
		}
	}
	return lRet;
}


WNAddrData* WNNetworkInfo::GetAdapterInfo(LONG lIndex)
{
	if (lIndex >= m_lCount)
	{
		return NULL;
	}
	else
	{
		return &m_AddrData[lIndex]; 
	}
}

VOID WNNetworkInfo::SetVirtualMac( CString& strMac )
{
	OutputDebugStringV(_T("SetVirtualMac %s"), strMac);
	for (LONG i = 0; i < m_lCount; i++)
	{
		m_AddrData[i].m_strVirtualMac = strMac;
	}
}

void WNNetworkInfo::OutputAdapterInfo()
{
	for (int i = 0; i < m_lCount; i++)
	{
		OutputDebugStringV(_T("Adapter %d:"), i);
		OutputDebugStringV(_T("Name is %s, VirtualMac is %d"), m_AddrData[i].m_strAdapterName, m_AddrData[i].IsVirtual());
		OutputDebugStringV(_T("Ip is %s"), m_AddrData[i].m_strIp);
		OutputDebugStringV(_T("MacAddress is %s"), m_AddrData[i].GetMacAddress());
	}
}